package hr.seminar;

import hr.genetics.models.Checkpoint;
import hr.genetics.models.Path;
import hr.geometrics.Line;
import hr.geometrics.Point;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class PathScanner {
	
	private List<Path> paths;

	public PathScanner() {
		
		this.scanPaths(null);
				
	}
	
	public PathScanner(String path) {
		this.scanPaths(path);
	}
	
	public List<Path> getPaths() {
		
		return this.paths;
		
	}
	
	private void scanPaths(String path) {
		
		this.paths = new ArrayList<Path>();
				
		try {
			Scanner scanner = null;
			if (path == null) {
				scanner = new Scanner( new File("/Users/mario/workspace/Seminar/import.txt") );
			} else {
				scanner = new Scanner(path);
			}
			
			String line;
			Path current = null;
			while (scanner.hasNextLine()) {
				line = scanner.nextLine();
				if (line.startsWith("PATH")) {
					if (current != null) {
						this.paths.add(current);
					}
					
					current = new Path(new Scanner(line.substring(5)).next());
				} else if (line.startsWith("START")) {
					current.setStartLine( this.getLineFromCoords(line.substring(6)));
				} else if (line.startsWith("NAME")) {
					current.setName(line.substring(new String("NAME ").length()));
				} else if (line.startsWith("LINE")) {
					current.addLine( this.getLineFromCoords(line.substring(5)) );
				} else if (line.startsWith("CHECKPOINT")) {
					current.addCheckpoint( this.getCheckointFromCoords(line.substring(11)) );
				} else if (line.startsWith("WIDTH")) {
					current.setWidth( new Double(line.substring(6)).intValue() );
				} else if (line.startsWith("HEIGHT")) {
					current.setHeight( new Double(line.substring(6)).intValue() );
				} else if (line.startsWith("ID")) {
					current.setId( new Integer(line.substring(3)) );
				}
			}
			
			paths.add(current);
			
		} catch (Exception e) {
			System.out.println(e.toString());
			System.exit(1);
		}
		
	}
	
	private Line getLineFromCoords(String coords) {
		
		Scanner sc = new Scanner(coords);
		
		return new Line(sc.nextInt(), sc.nextInt(), sc.nextInt(), sc.nextInt());
		
	}
	
	private Checkpoint getCheckointFromCoords(String coords) {
		
		Scanner sc = new Scanner(coords);
		
		return new Checkpoint(new Point(sc.nextInt(), sc.nextInt()), sc.nextInt());
		
	}
	
}
